<?php
/**
*
* @package acp
* @version 1.0.0 acp_introduction_required.ph Dakin Quelia
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp
*/
class acp_introduction_required
{
	var $u_action;
	var $new_config = array();
   
	function main($id, $mode)
	{
		global $db, $user, $auth, $template;
		global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx;
			
		$action	= request_var('action', '');
		$submit = isset($_POST['submit']) ? true : false;	
		$exlude_group_id = request_var('intro_exclude_groups', array(0));
		
		$form_key = 'acp_introduction_required';
		add_form_key($form_key);
	  
		switch($mode)
		{
			case 'config':
				$display_vars = array(
					'title'	=> 'ACP_INTRODUCTION_SETTINGS',
					'vars'	=> array(
						'legend1'				=> 'ACP_INTRODUCTION_SETTINGS',
						'intro_required_enable'	=> array('lang' => 'INTRODUCTION_ENABLE',	'validate' => 'bool',	'type' => 'radio:yes_no', 'explain' => true),
						'intro_forum_id'        => array('lang' => 'INTRODUCTION_FORUM_ID',    'validate' => 'int', 'type' => 'select', 'function' => 'make_forum_select', 'params' => array('{CONFIG_VALUE}', false, true, true, true, false, false), 'explain' => true),
                        'intro_group_id'        => array('lang' => 'INTRODUCTION_GROUP_ID',    'validate' => 'int',    'type' => 'select', 'function' => 'group_select_options', 'params' => array('{CONFIG_VALUE}', false, false), 'explain' => true),  
						'intro_exclude_groups'	=> array('lang'	=> 'INTRODUCTION_EXCLUDE_GROUPS',	'validate' => 'string',	'type' => 'custom', 'method' => 'intro_group_excludes_select', 'explain' => true)		
					)
				);
				
				if (isset($display_vars['lang']))
				{
					$user->add_lang($display_vars['lang']);
				}

				$this->new_config = $config;
				$cfg_array = (isset($_REQUEST['config'])) ? request_var('config', array('' => '')) : $this->new_config;
				$error = array();

				// We validate the complete config if whished
				validate_config_vars($display_vars['vars'], $cfg_array, $error);
				
				if ($submit && !check_form_key($form_key))
				{
					$error[] = $user->lang['FORM_INVALID'];
				}
				
				// Do not write values if there is an error
				if (sizeof($error))
				{
					$submit = false;
				}
				
				// We go through the display_vars to make sure no one is trying to set variables he/she is not allowed to...
				foreach ($display_vars['vars'] as $config_name => $null)
				{
					if (!isset($cfg_array[$config_name]) || strpos($config_name, 'legend') !== false)
					{
						continue;
					}
					
					$this->new_config[$config_name] = $config_value = $cfg_array[$config_name];

					if ($submit)
					{	
						set_config($config_name, $config_value);
					}
				}
				
				if ($submit)
				{
					if ($config_name == 'intro_exclude_groups' && !empty($exlude_group_id))
					{
						set_config('intro_exclude_groups', (string) implode(",", $exlude_group_id));
					}

					add_log('admin', 'LOG_CONFIG_UPDATED');
					trigger_error($user->lang['CONFIG_UPDATED'] . adm_back_link($this->u_action));
				}

				$this->page_title = $display_vars['title'];
				$this->tpl_name = 'acp_introduction_config';
				
				$template->assign_vars(array(
					'L_TITLE'			=> $user->lang[$display_vars['title']],
					'L_TITLE_EXPLAIN'	=> $user->lang[$display_vars['title'] . '_EXPLAIN'],

					'S_ERROR'			=> (sizeof($error)) ? true : false,
					'ERROR_MSG'			=> implode('<br />', $error),

					'U_ACTION'			=> $this->u_action)
				);

				foreach ($display_vars['vars'] as $config_key => $vars)
				{
					if (!is_array($vars) && strpos($config_key, 'legend') === false)
					{
						continue;
					}

					if (strpos($config_key, 'legend') !== false)
					{
						$template->assign_block_vars('options', array(
							'S_LEGEND'      => true,
							'LEGEND'        => (isset($user->lang[$vars])) ? $user->lang[$vars] : $vars)
						);

						continue;
					}

					$type = explode(':', $vars['type']);

					$l_explain = '';
					if ($vars['explain'] && isset($vars['lang_explain']))
					{
						$l_explain = (isset($user->lang[$vars['lang_explain']])) ? $user->lang[$vars['lang_explain']] : $vars['lang_explain'];
					}
					else if ($vars['explain'])
					{
						$l_explain = (isset($user->lang[$vars['lang'] . '_EXPLAIN'])) ? $user->lang[$vars['lang'] . '_EXPLAIN'] : '';
					}

					$content = build_cfg_template($type, $config_key, $this->new_config, $config_key, $vars);

					if (empty($content))
					{
						continue;
					}

					$template->assign_block_vars('options', array(
						'KEY'           	=> $config_key,
						'TITLE'            	=> (isset($user->lang[$vars['lang']])) ? $user->lang[$vars['lang']] : $vars['lang'],
						'S_EXPLAIN'       	=> $vars['explain'],
						'TITLE_EXPLAIN' 	=> $l_explain,
						'CONTENT'        	=> $content,
					));

					unset($display_vars['vars'][$config_key]);
				}
			break;
		 
			case 'userlist':
				$sort_days = request_var('st', 0);
				$sort_key = request_var('sk', 'ui');
				$sort_dir = request_var('sd', 'd');	
			
				$start = request_var('start', 0);
				$introduced = request_var('introduced', 0);
				
				// Sorting
				$limit_days = array(0 => $user->lang['ALL_ENTRIES'], 1 => $user->lang['1_DAY'], 7 => $user->lang['7_DAYS'], 14 => $user->lang['2_WEEKS'], 30 => $user->lang['1_MONTH'], 90 => $user->lang['3_MONTHS'], 180 => $user->lang['6_MONTHS'], 365 => $user->lang['1_YEAR']);
				$sort_by_text = array('uni' => $user->lang['SORT_NOT_INTRODUCED'], 'ui' => $user->lang['SORT_INTRODUCED']);
				$sort_by_sql = array('uni' => 'user_introduced', 'ui' => 'user_introduced');

				$s_limit_days = $s_sort_key = $s_sort_dir = $u_sort_param = '';
				gen_sort_selects($limit_days, $sort_by_text, $sort_days, $sort_key, $sort_dir, $s_limit_days, $s_sort_key, $s_sort_dir, $u_sort_param);
				
				$sql_sort = 'username ' . (($sort_dir == 'd') ? 'DESC' : 'ASC');

				$sql = 'SELECT user_id, username, username_clean, user_colour, user_regdate
						FROM ' . USERS_TABLE .  '
						WHERE user_introduced = ' . ($sort_key == 'ui' ? true : false) . '
							AND user_type <> ' . USER_IGNORE . '
                        ORDER BY ' . $sql_sort;  
				$result = $db->sql_query_limit($sql, $config['topics_per_page'], $start);
				
				$profile_url = (defined('IN_ADMIN')) ? append_sid("{$phpbb_admin_path}index.$phpEx", 'i=users&amp;mode=overview') : append_sid("{$phpbb_root_path}memberlist.$phpEx", 'mode=viewprofile');

				while ($row = $db->sql_fetchrow($result))
				{
					$template->assign_block_vars('userlist', array(
						'USERNAME'			=> get_username_string('full', $row['user_id'], $row['username'], $row['user_colour'], false, $profile_url),
						'REGISTERED_DATE'	=> $user->format_date($row['user_regdate']),
					));
				}
				$db->sql_freeresult($result);
				
				// Used for pagination
				$sql = 'SELECT COUNT(user_id) AS total_users FROM ' . USERS_TABLE . ' 
						WHERE user_introduced = ' . ($sort_key == 'ui' ? true : false) . ($sort_days ? " 
							AND user_introduced >= " . $sql_where : '') . ' 
							AND user_type <> ' . USER_IGNORE;	
				$result = $db->sql_query($sql);
				$count = (int) $db->sql_fetchfield('total_users');
				$db->sql_freeresult($result);
				
				// Send to template
				$template->assign_vars(array(
					'U_ACTION' 		=> $this->u_action,
					
					'S_LIMIT_DAYS'	=> $s_limit_days,
					'S_SORT_KEY'	=> $s_sort_key,
					'S_SORT_DIR'	=> $s_sort_dir,
			
					'PAGINATION' 	=> generate_pagination($this->u_action . "&amp;$u_sort_param", $count, $config['topics_per_page'], $start, true),
					'S_ON_PAGE' 	=> on_page($count, $config['topics_per_page'], $start),
				));
				
				$this->page_title = 'ACP_INTRODUCTION_USERLIST';
				$this->tpl_name = 'acp_introduction_userlist';
			break;
			
			default:
				trigger_error('NO_MODE', E_USER_ERROR);
			break;
		}
	}
	
	/**
	*  Introduction Forum Select
	***/
	function intro_forum_select($value, $key)
	{
		return make_forum_select($value, false, true, true, true, false, false);
	}
	
	/**
	*  Introduction Group Select
	***/
	function intro_group_select($value = false, $key)
	{
		return group_select_options($value, false, false);  
	}
	
	/**
	*  Introduction Group Multi Select Options
	***/
	function groups_multiselect_options($select_name = '', $select_id = array(), $exclude_ids = array())
	{
		global $user, $db;

		$sql = 'SELECT group_id, group_name, group_type FROM ' . GROUPS_TABLE . '
                WHERE ' . $db->sql_in_set('group_id', array_map('intval', $exclude_ids), true) .'
					AND group_name <> "REGISTERED_COPPA"
                ORDER BY group_type DESC, group_name ASC';
		$result = $db->sql_query($sql);

		$group_options = '<select id="' . $select_name . '" name="' . $select_name . '[]" multiple="multiple">';
		while ($row = $db->sql_fetchrow($result))
		{
			$selected = in_array($row['group_id'], $select_id) ? ' selected="selected"' : '';
			$group_options .= '<option ' . (($row['group_type'] == GROUP_SPECIAL) ? 'class="sep"' : '') . ' value="' . $row['group_id'] . '"' . $selected . '>' . ucfirst(strtolower((($row['group_type'] == GROUP_SPECIAL) ? $user->lang['G_' . $row['group_name']] : $row['group_name']))) . '</option>';
		}
		$db->sql_freeresult($result);
        $group_options .= '</select>';

		return $group_options;
	}  
	
	/**
	*  Introduction Group Excludes Select
	***/
	function intro_group_excludes_select($value)
	{
		global $config, $db;
		
		// Exclude groups
		$sql = 'SELECT group_id, group_name, group_type FROM ' . GROUPS_TABLE . "
				WHERE group_name IN ('BOTS')";
		$result = $db->sql_query($sql);
			
		$exclude = array();
		while ($exclude_row = $db->sql_fetchrow($result))
		{
			$exclude[] = $exclude_row['group_id'];
		}
		$db->sql_freeresult($result);
		
		$exclude_group = explode(",", $config['intro_exclude_groups']);
		
		return $this->groups_multiselect_options('intro_exclude_groups', $exclude_group, $exclude);
	}
}
?>