<?php
/**
 *
 * @author Dakin Quelia
 * @version $Id$
 * @copyright (c) 2011 Dakin Quelia
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 *
 */

/**
 * @ignore
 */
define('UMIL_AUTO', true);
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);

include($phpbb_root_path . 'common.' . $phpEx);
$user->session_begin();
$auth->acl($user->data);
$user->setup();

if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

// The name of the mod to be displayed during installation.
$mod_name = 'ACP_INTRODUCTION_REQUIRED';

/*
* The name of the config variable which will hold the currently installed version
* UMIL will handle checking, setting, and updating the version itself.
*/
$version_config_name = 'introduction_required_version';


// The language file which will be included when installing
$language_file = 'mods/info_acp_introduction_required';

/*
* Optionally we may specify our own logo image to show in the upper corner instead of the default logo.
* $phpbb_root_path will get prepended to the path specified
* Image height should be 50px to prevent cut-off or stretching.
*/
//$logo_img = 'styles/prosilver/imageset/site_logo.gif';

/*
* The array of versions and actions within each.
* You do not need to order it a specific way (it will be sorted automatically), however, you must enter every version, even if no actions are done for it.
*
* You must use correct version numbering.  Unless you know exactly what you can use, only use X.X.X (replacing X with an integer).
* The version numbering must otherwise be compatible with the version_compare function - http://php.net/manual/en/function.version-compare.php
*/
$versions = array(
	'1.0.0' => array(
	
		// Add fields in the users table
		'table_column_add' => array(
			 array(USERS_TABLE, 'user_introduced', array('BOOL', 0)), 
		),
		
		// Now add config
		'config_add' => array(
			array('intro_required_enable', false),
			array('intro_exclude_groups', 0, true),
			array('intro_forum_id', 0, true),
			array('intro_group_id', 0, true),
		),
		
		// Now add the module
		'module_add' => array(
			array('acp', 'ACP_CAT_GENERAL', 'ACP_INTRODUCTION_REQUIRED'),
			array('acp', 'ACP_INTRODUCTION_REQUIRED', array(
					'module_basename'	=> 'introduction_required',
					'module_langname'	=> 'ACP_INTRODUCTION_SETTINGS',
					'module_mode'		=> 'config',
					'module_auth'		=> 'acl_a_board',
				),
			),
			array('acp', 'ACP_INTRODUCTION_REQUIRED', array(
					'module_basename'	=> 'introduction_required',
					'module_langname'	=> 'ACP_INTRODUCTION_USERLIST',
					'module_mode'		=> 'userlist',
					'module_auth'		=> 'acl_a_board',
				),
			),
		),
		
		// Clear the general cache as well as the templates, imagesets and themes cache
		'cache_purge' => array(''),
	),
);

// Include the UMIL Auto file, it handles the rest
include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);

?>